<id>
din1031:ssieliana
</id>

<version>
1.0.0
</version>

<edit file>
$boarddir/SSI.php
</edit file>

<search for>
function ssi_topTopicsViews($num_topics = 10, $output_method = 'echo')
{
	return ssi_topTopics('views', $num_topics, $output_method);
}
</search for>

<replace>
function ssi_topTopicsViews($num_topics = 10, $output_method = 'echo')
{
	return ssi_topTopics('views', $num_topics, $output_method);
}

/*
Master SSI Function for Eliana, easier is to use ssi_elianaHighest and ssi_elianaLowest
$type 'good' or 'bad', standard is good =P
Normal calculate everytime the total which callculated elianaGood - elianaBad, 
but if you only like to have the highest postitve Eliana than set this option to false.
Example what is the diffrent
3 user with +14/-10, +20/-10, +12/-0
will be sorted by the $onlyTotal true like -> +12/0, +20/-10, +14/-10 <- because the first 
have total of 12. If you set it to false it will be look like this -> +20/-10, +14/-10, +12/0 
because +20 is the highest. Hope it's clear, ahh i forgot the total thing work only on 
positive/negativ Eliana count if you use standard it will callcualte evertime ;D.
The showTotal will show only the Total Value of the Eliana ;).
*/
function ssi_eliana($type = 'good', $topMembers = 5, $onlyTotal = true, $showTotal = false, $output_method = 'echo')
{
	global $db_prefix, $scripturl, $modSettings, $context;
	
	// If the mod is disabled, do nothing.
	if (empty($modSettings['eliana_enabled']))
		return ($output_method != 'echo' ? array() : '');
	
	//Fixes :)
	$topMembers = (int) $topMembers;
	$topMembers = empty($topMembers) || $topMembers < 0 ? 5 : $topMembers;
	$onlyTotal = !is_bool($onlyTotal) ? true : $onlyTotal;
	$showTotal = !is_bool($showTotal) ? true : $showTotal;

	//Speed it up a little :) if the user count is lower than topMembers than use this :)
	$topMembers = $context['common_stats']['total_members'] <= $topMembers ? $context['common_stats']['total_members'] : $topMembers;

	//Select the correct sql for the select you made :)
	if($onlyTotal)
		$sql = "FLOOR(1000000+elianaGood+karmaGood-elianaBad-karmaBad)"; //It look strange... but there is small bug in SQL on negativ results...
	else 
		$sql = "elianaGood+karmaGood";
	
	//Load the Eliana Good Data
	$results = db_query("
		SELECT realName, elianaGood, elianaBad, karmaGood, karmaBad, ID_MEMBER 
		FROM {$db_prefix}members 
		ORDER BY $sql ".($type != 'good' ? 'ASC' : 'DESC')."
		LIMIT $topMembers", __FILE__, __LINE__);
		
	$return = array();
	$colorids = array();
	
	while($row = mysql_fetch_assoc($results)) {
		$return[] = array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'href' => $scripturl . '?action=profile;u=' . $row['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>',
			'elianaGood' => $row['elianaGood'] + $row['karmaGood'],
			'elianaBad' => $row['elianaBad'] + $row['karmaBad'],
			'elianaTotal' => $row['elianaGood'] + $row['karmaGood'] - $row['elianaBad'] - $row['karmaBad'],
		);
		$colorids[$row['ID_MEMBER']] = $row['ID_MEMBER'];
	}	
	mysql_free_result($results);
	
	//Add colors only on installed SSI Member Color Link
	if(function_exists('ssi_loadColors') && !empty($colorids)) {
		global $color_profile;
		ssi_loadColors($colorids);
		foreach($return as $k => $p) {
			$profile = $color_profile[$p['id']];
			if(!empty($profile)) {
				$return[$k]['link'] = $profile['link'];
			}
		}
	}
	
	//Output?
	if($output_method != 'echo')
		return $return;
	
	//Okay some output =)
	if(empty($return))
		return;

	echo '
		<table class="ssi_table">';
	foreach ($return as $temp) {
		echo '
			<tr>
				<td align="right">
					', $temp['link'], '
				</td>';
		if ($showTotal)
			echo '
				<td align="left">', $temp['elianaTotal'], '</td>';
		else
			echo '
				<td align="left">+', $temp['elianaGood'], '/-', $temp['elianaBad'], ($onlyTotal ? ' ('.$temp['elianaTotal'].')' : ''), '</td>';
		echo'
			</tr>';
	}
	echo '
		</table>';	
}

//Show user with highest Eliana, Discription for onlyTotal see ssi_eliana
function ssi_elianaHighest($topMembers = 5, $onlyTotal = true, $showTotal = false, $output_method = 'echo') 
{
	return ssi_eliana('good', $topMembers, $onlyTotal, $showTotal, $output_method);
}

//Show user with lowest Eliana, Discription for onlyTotal see ssi_eliana
function ssi_elianaLowest($topMembers = 5, $onlyTotal = true, $showTotal = false, $output_method = 'echo') 
{
	return ssi_eliana('bad', $topMembers, $onlyTotal, $showTotal, $output_method);
}
</replace>

<edit file>
$boarddir/ssi_examples.php
</edit file>

<search for>
			<h3>Top Topics by View Function: &lt;?php ssi_topTopicsViews(); ?&gt;</h3>
</search for>

<replace>
			<h3>Highest Karma Function: &lt;?php ssi_elianaHighest(); ?&gt;</h3>
			<?php ssi_elianaHighest(); flush(); ?>

		<hr />

			<h3>Lowest Karma Function Function: &lt;?php ssi_elianaLowest(); ?&gt;</h3>
			<?php ssi_elianaLowest(); flush(); ?>

		<hr />

			<h3>Top Topics by View Function: &lt;?php ssi_topTopicsViews(); ?&gt;</h3>
</replace>
